<?php
/**
 * ipasspay—direct 异步通知
 */
$config_data  = $db->Execute("select * from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", keys()) . "')");

function keys() {
    return array('MODULE_PAYMENT_IPASSPAY_DIRECT_STATUS',
        'MODULE_PAYMENT_IPASSPAY_DIRECT_MERCHANT_ID',
        'MODULE_PAYMENT_IPASSPAY_DIRECT_APP_ID',
        'MODULE_PAYMENT_IPASSPAY_DIRECT_API_SECRET',
        'MODULE_PAYMENT_IPASSPAY_DIRECT_GATEWAY',
        'MODULE_PAYMENT_IPASSPAY_DIRECT_GATEWAY_VERSION',
        'MODULE_PAYMENT_IPASSPAY_DIRECT_ASYN_NOTIFY',
        'MODULE_PAYMENT_IPASSPAY_DIRECT_ZONE',
        'MODULE_PAYMENT_IPASSPAY_DIRECT_ORDER_STATUS_ID',
        'MODULE_PAYMENT_IPASSPAY_DIRECT_SORT_ORDER');
    'MODULE_PAYMENT_IPASSPAY_DIRECT_ORDER_STATUS_ID';
}
$merchant_id = MODULE_PAYMENT_IPASSPAY_DIRECT_MERCHANT_ID;
$app_id = MODULE_PAYMENT_IPASSPAY_DIRECT_APP_ID;
$api_secret = MODULE_PAYMENT_IPASSPAY_DIRECT_API_SECRET;

$insert_id = $_REQUEST['custom_data'];
$order_no = $_REQUEST['order_no'];
$gateway_order_no = $_REQUEST['gateway_order_no'];
$order_currency = $_REQUEST['order_currency'];
$order_amount = $_REQUEST['order_amount'];
$order_status = $_REQUEST['order_status'];
$order_signature = $_REQUEST['signature'];

$signature = hash('sha256', $merchant_id.$app_id.$order_no.
    $gateway_order_no.$order_currency.$order_amount.
    $order_status.$api_secret);

//验签
if ($signature == $order_signature) {
    $auth_status = MODULE_PAYMENT_IPASSPAY_DIRECT_ORDER_STATUS_ID; //当前订单状态
    switch ($order_status) {
        //成功
        case '2':
        case '4':
            $auth_status = 2;
            break;
        case '3':
            //失败
            $auth_status = 7;
            break;
        default:
            break;
    }

    //修改交易状态和说明
    $sql_data_array = array('orders_status' => $auth_status,
        'orders_date_finished' => 'now()',
    );
    zen_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = ' . (int) $insert_id); //更新订单状

    $res = array(
        'errcode' => '0',
        'errmsg' => 'success'
    );
} else {
    $res = array(
        'errcode' => '1',
        'errmsg' => 'failure'
    );
}
echo json_encode($res);
exit;